/**************************
	JSCM
	Ariel Flesler
	Version 1.0.1
**************************/

var SECURITY_ID	= max_security_id
var PLUGIN_NAME = "JSCM"
var QUERIES_FILE = "scripts.txt";
/*var $hl = $('<div>').css({background:"red",border:"1px solid blue",display:"none",position:"absolute"});
$H('body').append($hl);*/
/*var expendable_img = document.createElement('img');expendable_img.src = "css/external.css";
var external_css = document.createElement("link");external_css.href = expendable_img.src;external_css.type="text/css";external_css.rel="stylesheet";
expendable_img = null;*/
var seeing = 0;

function readScripts() {
	return (external.readFile(SECURITY_ID,PLUGIN_NAME,QUERIES_FILE) || "");
}
function writeLine(script,title) {
	var qs = readScripts();
	qs+='<li><a>'+title+'</a><p>'+script+'</p></li>';
	external.writeFile(SECURITY_ID,PLUGIN_NAME,QUERIES_FILE,qs)
}
function writeScripts(scripts) {
	external.writeFile(SECURITY_ID,PLUGIN_NAME,QUERIES_FILE,scripts)
}
function currtab(){
	return external.get_tab(SECURITY_ID, external.cur_sel);	
}
function $H(str,context){
	return (!context ? $(str,currtab().document) : $(str,context));
}

function mark(tag,index){
	mark.pborder = ($H(tag).eq(index).css('border') || "");
	//$H(tag).eq(index).not(':text,:password,:button,:submit').css('border','2px solid red');
	$H(tag).eq(index).css('border','2px solid red');
	/*$hl.css({height:$H(tag).eq(index).css('height'),width:$H(tag).eq(index).css('width'),left:$H(tag).eq(index).css('left'),top:$H(tag).eq(index).css('top')});
	$hl.show();*/
	//$H(tag).eq(index).addClass('highlight');
}
function unmark(tag,index){
	//$H(tag).eq(index).not(':text,:password,:button,:submit').css('border', mark.pborder);
	$H(tag).eq(index).css('border', mark.pborder);
	//$hl.hide();
	//$H(tag).eq(index).removeClass('highlight');
}

function getSelector(tag,index){
	var $elem = $H(tag).eq(index);
	if($elem.attr('id') &&  $elem.attr('id') != "")
		$('#console').val('$("#'+$elem.attr('id')+'")');
	else if($elem.attr('class') &&  $elem.attr('class')!= "")
		$('#console').val('$("'+tag+'.'+$elem.attr('class')+':eq('+$H(tag+'.'+$elem.attr('class')).index($elem[0])+')")');
	else
		$('#console').val('$("'+tag+':eq('+index+')")');
}

function checkResult(res){
	if(typeof res == 'string')
			return "<em>" + '"'+ res +'"' + "</em>";
	else if(typeof res == 'number' || typeof res == 'boolean')
			return "<i>" + res.toString() + "</i>";
	else if(res instanceof Array){
			var str = '[';
			for(var i in res){
				if(str != '[')
						str+=', ';
				str	+= checkResult(res[i]);						
			}
			str+=']';
			return str;
	}
	else if(typeof res == 'object' && res.tagName && res.tagName != ""){
			var parameter = '"'+res.tagName.toLowerCase()+'"'+","+$H(res.tagName.toLowerCase()).index($(res)[0]);
			return "<a onMouseOver='mark("+parameter+")' onMouseOut='unmark("+parameter+")' href='*' onClick='getSelector("+parameter+");return false;'>" + res.tagName.toLowerCase() + "</a>" +(res.id != "" ? "<em>#" + res.id + "</em>": "")+(res.className != "" ? "<i>." + res.className + "</i>": "");
	}
	else{
		return "null"
	}
}

function deleteScript(){
	var r=confirm("Are you sure you want to delete this script?")
  if (!r)
  	return;
	$(this).unbind('click');
	$(this).parent('li').remove();
	writeScripts(	$('<div>').html($('#scripts').html())
													.find('img').remove()
													.end().html());
}

function loadStoredScripts(){
	$('#scripts li a,script li img').unbind('click')
	$('#scripts').empty();
	$('#scripts').append(readScripts());
	$('#scripts li a').before('<img src="images/X.gif" class="delete" />');
	$('#scripts li img.delete').click(deleteScript);
	$('#scripts li a').click(function(){
		$('#console').val($(this).siblings('p').text());
	});	
}

$(function(){
	
	loadStoredScripts();	
	
	$("#store").click(function(){
		var name=prompt("Give the script a name..","")
  	if (name!=null && name!="" && $('#console').val() != "" ){
    	writeLine($('#console').val(),name);
    	loadStoredScripts();
    }else
    	alert('Invalid entry');
	});
	$('h1').toggle(
		function(){
			$(this).next('div.container').hide();
			$(this).prev('img.indicator').attr('src','images/+.gif');
		},
		function(){
			$(this).next('div.container').show();
			$(this).prev('img.indicator').attr('src','images/-.gif');
		}
	);
	$("#refresh").click(function(){
			window.location.reload( false );
	});
	$("#clearResults").click(function(){
			$('#results').empty();
			seeing = -1;
	});
	$("#clearConsole").click(function(){
			$('#console').val('');
	});
	$('#console').keyup(function(event){
			//arriba 38, abajo 40, 33 pgup, 34 pgdown
			if(event.keyCode == 33){
				if(seeing > 0){
					seeing--;
					$('#console').val($('#results li').eq(seeing).find('p.first').text());
				}
			}else if(event.keyCode == 34){
				if(seeing < $('#results').find('li').size()){
					seeing++;
					$('#console').val($('#results li').eq(seeing).find('p.first').text());
				}
			}
	});
	$('#execute').click(function(){
			try{
				if($('#console').val() == '')
					return;
				var orig_script = $('#console').val();
				var script = orig_script.replace(/\$\(\"/g ,'$H("')
																.replace(/\$\(\'/g ,"$H('")
																.replace(/JQuery\(\"/g ,'$H("')
																.replace(/JQuery\(\'/g ,"$H('");
				var str;				
				var res = eval(script);
				if(res && res.get && res.get() != null){
						res=res.get()
				}
				str = checkResult(res);				
		}catch(err){
			str = '<a>'+err.description+'</a>';
		}
		$('#console').val('');
		/*$('#results').append('<li><p class="first">'+(orig_script.length <= 45 ? orig_script : orig_script.substring(0,42)+'..')
																																				+'</p><p class="last">'+str+'</p></li>');		*/
		$('#results').append('<li><p class="first">'+orig_script+'</p><p class="last">'+str+'</p></li>');
		seeing = $('#results').find('li').size();
	});
});